client/Center() //which macro to set, in this case it is 5 on numberpad
	mob.shoot() //when 5 is press, it goes to the mob proc shoot
mob
	icon = 'icons.dmi'
	icon_state = "black"
	Login()
		src.weapon = new/obj/Guns/handGun //We set our variable so it won't be null
		..()
	var
		hasFired = 0

		/* The variable below is rather important and one of the cooler parts of this
		demo. This variable holds the gun that the user is currently holding. In a game
		set up, this variable would allow you to access all of the gun's information
		without having to save such information to user variables.*/

		obj/Guns/weapon
	verb
		Shoot()
			shoot()

		/*The following equip verbs change the variable mentioned above to hold a
		certain gun object*/

		EqiupHandGun()
			set name = "Equip Hand Gun"
			src.weapon = new/obj/Guns/handGun
			src << "You have equipped a [src.weapon.name]!"
		EqiupShotgun()
			set name = "Equip Shotgun"
			src.weapon = new/obj/Guns/shotgun
			src << "You have equipped a [src.weapon.name]!"
		EqiupRifle()
			set name = "Equip Rifle"
			src.weapon = new/obj/Guns/rifle
			src << "You have equipped a [src.weapon.name]!"
	proc
		shoot()
			if(!src.hasFired) //Precautioned used to keep people from holding down center for mass fire
				src << "You fired!"
				src.hasFired = 1
				spawn(15)
					src.hasFired = 0
				var
					mob/target = null //This will hold our final target, if no target is found it stays 0
					distance = src.weapon.range + 1 //It is set outside the weapon's range since any target will be within this value
				for(var/mob/M as mob in oview(src.weapon.range))

					/*The following set of if statements may be a tad bit intimidating but it's
					actually fairly simple. Imagine now that we would have to check which direction
					our character is facing. Now that we know which way we're facing, we check
					if the mob we're checking is within the firing range. Simple math is applied
					here to check, using x and y coordinates. For diagonals, the slope formula is
					applied to see if they are within path.

					Now the way I have set this up is more to have it look nice, if I used a
					regular system of ifs to check if the mob is within path, I'd have to code
					to set the target under every if statement and that would make the code look
					messy. To figure this out I applied simple boolean knowledge and set it up so
					that if one of the if statements rang true, it would flip to false and break out
					of the ifs, and would then apply the target (only one code see?). If none of
					the ifs were to be false (current target is not within path) then the falses
					would be flipped to true until the continue, restarting the for loop.*/

					if(!(src.dir == NORTH && src.x == M.x && src.y < M.y))
						if(!(src.dir == SOUTH && src.x == M.x && src.y > M.y))
							if(!(src.dir == EAST && src.y == M.y && src.x < M.x))
								if(!(src.dir == WEST && src.y == M.y && src.x > M.x))
									var/slope
									if(M.x - src.x == 0)
										slope = 0
									else
										slope = (M.y - src.y)/(M.x - src.x)
									if(!(src.dir == NORTHEAST && slope == 1 && M.y > src.y))
										if(!(src.dir == NORTHWEST && slope == -1 && M.y > src.y))
											if(!(src.dir == SOUTHEAST && slope == -1 && M.y < src.y))
												if(!(src.dir == SOUTHWEST && slope == 1 && M.y < src.y))
													continue

/* Now we check if the mob we're currenting checking out is closer than a previous mob
(in case we have two people within the line of fire, we want to shoot the closer one!*/

					var/tempDist = get_dist(src.loc, M.loc)
					if(tempDist < distance)
						target = M
						distance = tempDist
				if(target) //If there's been a target, shoot 'em!
					beenShot(target, weapon)

		beenShot(var/mob/M, var/obj/Guns/wep)
			src << "[M] has been shot for [wep.power] damage with a [wep.name]!"
			//Here is where you would take health away, check for death, ect...
	Targets
		Jon
			icon_state = "blue"
		Robb
			icon_state = "red"
		Bran
			icon_state = "pink"
		Rickon
			icon_state = "yellow"

obj
	Guns
		var
			power = 5
			range
		handGun
			name = "Hand Gun"
			range = 5
		shotgun
			name = "Shotgun"
			range = 3
		rifle
			name = "Rifle"
			range = 10

turf
	Terrain
		icon = 'icons.dmi'
		Grass
			icon_state = "grass"
		Wall
			icon_state = "wall"
			density = 1
			opacity = 1



